/*
 * UsingChild.cpp
 *
 *  Created on: Mar 5, 2016
 *      Author: kesalin
 */

#include "UsingChild.h"
#include "Child.h"
#include "VisibleChild.h"

void UsingChild::Print(Holder<Child*> * holder)
{
    holder->Print();
}

void UsingChild::Print(Holder<VisibleChild*> * holder)
{
    holder->Print();
}

void UsingChild::Use()
{
    printf("\n=== UsingChild::Use() ===\n");
    Child* child = new Child();
    Holder<Child*>* hc = new Holder<Child*>(child);
    Print(hc);
    delete child;
    delete hc;

    VisibleChild* visibleChild = new VisibleChild();
    Holder<VisibleChild*>* hc2 = new Holder<VisibleChild*>(visibleChild);
    Print(hc2);
    delete visibleChild;
    delete hc2;
}
