/*
 * UsingBase.cpp
 *
 *  Created on: Mar 5, 2016
 *      Author: kesalin
 */

#include "UsingBase.h"
#include "VisibleChild.h"

void UsingBase::Print(Holder<Base*> * holder)
{
    holder->Print();
}

void UsingBase::Print(Holder<Child*> * holder)
{
    holder->Print();
}

void UsingBase::Print(Holder<VisibleChild*> * holder)
{
    holder->Print();
}

void UsingBase::Use()
{
    printf("\n=== UsingBase::Use() ===\n");
    Base* base = new Base();
    Holder<Base*>* hb = new Holder<Base*>(base);
    Print(hb);
    delete base;
    delete hb;

    VisibleChild* visibleChild = new VisibleChild();
    Holder<VisibleChild*>* hc2 = new Holder<VisibleChild*>(visibleChild);
    Print(hc2);
    delete visibleChild;
    delete hc2;
}
